import zipfile
import xml.dom.minidom
import xml.sax
from xml.dom.minidom import Document
import string
from xml.sax import saxutils
from xml.dom.ext.reader import Sax2
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump
from common import FakeRequest, FakeUpload

class Importer:
    def __init__(self, root_element, file=None):
	"""Creates impoter"""
        self.binarydata = DataTable()
        self.idmap = {}
        self.timecounters=[0,0,0,0,0,0,0,0,0,0]
        if file:
            self.loadZip(file)
            if self.root.tagName != root_element:
                raise 'Import error',"XML data should specify document %s. Instead, document %s was found." % (root_element, self.root.tagName)


    def importQT(self, elem, course, uname):
	comment =  self.get_text(elem.getElementsByTagName("qticomment")[0])
        for abc in elem.getElementsByTagName("section"):
		sekt_title =  self.get_attr(abc,'title')
		for bcd in abc.getElementsByTagName("item"):
			try:
				qt_tyyp =  self.get_attr(bcd,'title')
			except IndexError:
				qt_tyyp = ''
			try:
				qt_id = self.get_attr(bcd,'ident')
			except IndexError:
				qt_id = ''
			try:
				qt_story = self.get_text(bcd.getElementsByTagName("qticomment")[0])
			except IndexError:
				qt_story = ''
			pelem = bcd.getElementsByTagName("presentation")[0]
			try:
				qt_quiz = self.get_text(pelem.getElementsByTagName("mattext")[0])
			except IndexError:
				qt_quiz = ''
			try:
				photo_data = self.binarydata.getData(
					self.get_attr(pelem.getElementsByTagName("matimage")[0],'uri'))
			except IndexError:
				pass
			try:
				qt_link = self.get_text(pelem.getElementsByTagName("matemtext")[0])
				qt_linkd = self.get_attr(pelem.getElementsByTagName("matemtext")[0],'uri')
			except IndexError:
				qt_link = ''
				qtlinkd = ''

			try:
				r_grp =  pelem.getElementsByTagName("response_grp")
				r_grp1 = 1
			except IndexError:
				r_grp1 = 0
			try:
				r_lid =  pelem.getElementsByTagName("response_lid")
				r_lid1 = 1
			except IndexError:
				r_lid1 = 0
			try:
				r_xy = pelem.getElementsByTagName("response_xy")
				r_xy1 = 1
			except IndexError:
				r_xy1 = 0
			try:
				r_str = pelem.getElementsByTagName("response_str")
				r_str1 = 1
			except IndexError:
				r_str1 = 0
			try:
				r_num = pelem.getElementsByTagName("response_num")
				r_num1 = 1 
			except IndexError:
				r_num1 = 0
	return

    def test(self,elem, folder, uname, indeks,loop=0):
	for bcd in elem.childNodes:
		#print bcd
		if bcd.nodeType == 1 and bcd.nodeName == 'resource':
			pid = self.get_attr(bcd,"identifier")
			if indeks[self.eemalda(pid)] == self.eemalda(folder.id):
				tyyp = self.get_attr(bcd,'type')
				name = self.get_text(bcd.getElementsByTagName("title")[0])
				if tyyp == 'file':
					data_name = self.get_attr(bcd.getElementsByTagName("file")[0],'href')
					data = self.binarydata.getData(data_name)
					file = folder.add_file(name, 
						FakeUpload(name,data,'application/msword'))
				if tyyp == 'memo':
					sisu = self.get_text(bcd.getElementsByTagName("description")[0])
					memo = folder.add_memo(name,sisu)
				if tyyp == 'URL':
					sisu = self.get_attr(bcd,'href')
					link = folder.add_link(name, sisu)
	#print indeks[self.eemalda(folder.id)]
	if loop==0:
		folder = getattr(folder,folder.id)
		self.importItems(elem,folder,uname,indeks)
	return folder

    def importItems(self, elem, course, uname, indeks,loop=0):
	if loop:
		self.test(elem,course,uname,indeks,loop=1)
	for abc in course.objectValues():
		if abc.meta_type == 'WebtopFolder': 
			folder = getattr(course,abc.id)
			self.test(elem,folder,uname, indeks)
	return "kala"

    def get_text(self,elem):
	res=u''
	for line in elem.childNodes:
        	res += line.nodeValue
	return to_utf8(res)
    def get_attr(self,elem,name):
	return to_utf8(elem.getAttribute(name))

    def kaust(self, elem, kname, parent, uname,fid, pid,indeks):
	folder = parent.add_folder(kname)
	indeks[fid] = self.eemalda(folder.id)
	self.doFolder(elem, folder, uname, indeks)
	return folder
   
    def eemalda(self,pid):
	import re
	try:
		number = int(re.sub('[a-zA-Z]','',pid))
	except ValueError:
		number = 0
	return number 

    def doFolder(self,elem,course, uname, indeks):
	""" do folder in bookshelf """
	for bcd in elem.childNodes:
		if bcd.nodeType == 1 and bcd.nodeName == 'item':
			fid = self.eemalda(self.get_attr(bcd,"identifier"))
			pid = self.eemalda(self.get_attr(bcd,"identifierref"))
			kname = self.get_text(bcd.getElementsByTagName("title")[0])
			self.kaust(bcd, kname, course,uname,fid, pid,indeks)
	return indeks 

    def importOrg(self,elem,course):
	for abc in elem.getElementsByTagName("organization"):
		if self.get_text(abc.getElementsByTagName("title")[0]) == "Raamaturiiul":
			nelem = abc
	abc = nelem.getElementsByTagName("item")[0]
	return abc

    def import_course(self,elem,courses,teacher):
	id = courses.add_course_impl(teacher)
	course = courses.get_child(str(id))
	title = elem.getElementsByTagName("imsmd:title")[0]
        title_c = self.get_text(title.getElementsByTagName("imsmd:langstring")[0])

	desk = elem.getElementsByTagName("imsmd:description")[0]
	desk_c = self.get_text(desk.getElementsByTagName("imsmd:langstring")[0])
	title_c = "imported_"+title_c
	course.update(title_c,desk_c,'org','meetodid',0,0,'tekst',None,0)
	course.kontrolliRyhmaLaud()
	course.add_folder('CourseFolder')
	return course 

    def loadZip(self,file):
        """Loads a zipped FLE content file.

        - file: the file name to load."""
        zip = zipfile.ZipFile(file,"r",zipfile.ZIP_DEFLATED)

        #xmlstring = unicode(
        #    zip.read("fledom.xml"), 'utf-8').encode("utf-8")
        xmlstring = zip.read("imsmanifest.xml")
        try:
            self.dom = xml.dom.minidom.parseString(xmlstring)
        except UnicodeError:
            print "XML data is not utf-8 encoded! Detecting encoding..."
            import re
            encoding = re.search('encoding="([-a-zA-Z0-9]*)">',xmlstring).group(1)
            print "Transforming from %s to utf-8..." % encoding
            xmlstring = unicode(xmlstring,encoding).encode("utf-8")
            self.dom = xml.dom.minidom.parseString(xmlstring)
        self.root = self.dom.firstChild

        for name in zip.namelist():
            if name[:4]=='data':
                self.binarydata.restoreData(name,zip.read(name))
        zip.close()



class Kirjutus:
    def __init__(self, ivajuur, kursusenr):
        """Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt"""
        # Paisktabel failandmete hoidmiseks
        self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
#        self.juur=self.dom.createElement("manifest")
#        self.dom.appendChild(self.juur)
#        self.juur.appendChild(self.dom.createElement("metadata"))
#        self.orgd=self.dom.createElement("organizations")
#        self.juur.appendChild(self.orgd)
#        self.orgn=self.dom.createElement("organization")
#        self.orgd.appendChild(self.orgn)
        self.iva=ivajuur
        self.kursusenr=kursusenr
#        print "nr "+str(kursusenr)
        self.kursus=getattr(ivajuur.courses, str(kursusenr))
        self.juur=self.kirjutaManifest(self.dom, "kursuse pealkiri")
#        self.kirjutaOsad()
        
    def kirjutaManifest(self, alus, pealkiri=""):
        "Manifesti ploki loomine"
        m=self.dom.createElement("manifest")
	m.setAttribute('identifier','IVA')
	m.setAttribute('version','1.1')
	m.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
	m.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1')
	m.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	m.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        md=self.dom.createElement("metadata")
        m.appendChild(md)

	mds=self.dom.createElement('schema')
	md.appendChild(mds)
	text = self.dom.createTextNode('IMS Content')
	mds.appendChild(text)

	mdv=self.dom.createElement('schemaversion')
	md.appendChild(mdv)
	mdv.appendChild(self.dom.createTextNode('1.1'))

	self.rekord(md, self.kursus.get_name(),self.kursus.get_description())

        #t=self.dom.createElement("title")
        #md.appendChild(t)
        #t.appendChild(self.dom.createTextNode(pealkiri))

        orgnz=self.dom.createElement("organizations")
        m.appendChild(orgnz)

	#bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
	#abc = self.kirjutaRaamatustrukt(bcd)
	#bcd.appendChild(abc)
	bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
        self.kirjutaRaamatustrukt(bcd)
	
	self.kirjutaToo(orgnz, "Teadmuspaja")
	self.kirjutaToo(orgnz, "Meediapaja")
	self.kirjutaToo(orgnz, "Wiki")
	self.kirjutaToo(orgnz, "QT")

        m.appendChild(self.dom.createElement("resources"))

	self.tooManifest(m,'bookshelf','riiul')
	self.tooManifest(m,'teadmuspaja','teadmuspaja')
	self.tooManifest(m,'meedia','meediapaja')
	self.tooManifest(m,'QT','QT')

        alus.appendChild(m)
        return m

    def kirjutaTPajaRes(self, vanem):
	tulem = self.dom.createElement('resources')
	for ctx in self.kursus.get_children("CourseContext"):
		rek = self.dom.createElement('teadmuspaja')
		tulem.appendChild(rek)	
		id = self.dom.createElement('id')
		id.appendChild(self.dom.createTextNode(ctx.get_id()))
		rek.appendChild(id)
		elem = self.dom.createElement('title')
		elem.appendChild(self.dom.createTextNode(ctx.get_name()))
		rek.appendChild(elem)
		elem2 = self.dom.createElement('lkirjeldus')
		elem2.appendChild(self.dom.createTextNode(ctx.get_description()))
		rek.appendChild(elem2)
                elem3 = self.dom.createElement('pkirjeldus')
                elem3.appendChild(self.dom.createTextNode(ctx.get_long_description()))
		rek.appendChild(elem3)
		rek.appendChild(self.exportTTS(ctx.get_thinking_type_set()))

        	for note in ctx.get_children('Note'):
        	    self.exportNote(rek,note)

        vanem.appendChild(tulem)
        return tulem

    def exportNote(self,frag,note):
        """Exports the given note."""
        newElem = self.dom.createElement
        newText = self.dom.createTextNode

        elem = newElem("thread-topic")
        elem.setAttribute("id",note.get_id())
        elem2 = newElem("metadata")
        elem3 = newElem("title")
        elem3.appendChild(newText(note.get_real_subject()))
        elem2.appendChild(elem3)
        elem3 = newElem("creator")
        elem3.appendChild(newText(note.get_author()))
        elem2.appendChild(elem3)

        elem3 = newElem("extra-meta")
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","metatype")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText("Note"))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","parent")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText(note.parent().get_id()))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","type")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText(note.get_tt_id()))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem2.appendChild(elem3)
        elem.appendChild(elem2)

        elem2 = newElem("source")
        elem3 = newElem("p")
        elem3.appendChild(newText(note.get_body()))
        elem2.appendChild(elem3)

        if note.get_url()!='':
            elem3 = newElem("internet-source")
            elem3.setAttribute("url",note.get_url())
            elem3.setAttribute("link-name",note.get_url_name())
            elem2.appendChild(elem3)

        if note.has_image():
            name = self.binarydata.storeData(
                note.get_image_data())
            elem3 = newElem("figure")
            elem4 = newElem("figure-source")
            elem4.setAttribute("entity",name)
            elem3.appendChild(elem4)
            elem4 = newElem("figure-text")
            elem5 = newElem("p")
            elem5.appendChild(newText(note.get_image_name()))
            elem4.appendChild(elem5)
            elem3.appendChild(elem4)
            elem2.appendChild(elem3)

        elem.appendChild(elem2)

        frag.appendChild(elem)

        #for reply in note.get_children('Note'):
        #    self.exportNote(frag,reply)


    def exportTTS(self,set):
        """Exports the given knowledgetypeset."""
	"""  Siit saame teadmustyybistiku nime """
        newElem = self.dom.createElement
        newText = self.dom.createTextNode

        elem = newElem("knowledge-object")
        elem.appendChild(newText(set.get_name()))

        return elem

    def kirjutaMPajaRes(self, vanem):
          #et lheks samasse hoidlass
        #tulem = ex.exportJamming(self.kursus)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata
	tulem = self.dom.createElement('Jamming')
        for js in self.kursus.get_child('jamming').get_children('JamSession'):
	    elem = self.dom.createElement("JamSession")
	    elem.setAttribute('CourseName', self.kursus.get_name())
	    elem.setAttribute('Name', js.get_name())
	    elem.setAttribute('Type', js.get_type())
	    elem.setAttribute('Descr', js.get_description())
	    elem.setAttribute('ID', js.get_id())
	    tulem.appendChild(elem)

	    first = js.get_starting_artefact_id()
	    for ja in js.get_children('JamArtefact'):
		if ja.get_id() == first:
			art = self.dom.createElement('Artefact')
			art.setAttribute('Name', ja.get_real_name())
			art.setAttribute('Author', str(ja.get_author()))
			art.setAttribute('ID', ja.get_id())

			annotations = self.dom.createElement('Annotations')
			for tple in ja.get_real_annotations():
				try:
					(uname, a_time, a_text, censored, censorer) = tple
				except ValueError:
					(uname, a_time, a_text) = tple
					censored=0
					censorer=''
				a_elem = self.dom.createElement('Annotation')
				a_elem.setAttribute('Author', uname)
				a_elem.setAttribute('Date', repr(a_time))
				text = self.dom.createElement('Text')
				text.appendChild(self.dom.createTextNode(a_text))
				a_elem.appendChild(text)
				annotations.appendChild(a_elem)
				art.appendChild(annotations)

				name = self.binarydata.storeData(ja.get_real_data())
				link = self.dom.createElement('DataLink')
				link.setAttribute('LocalName', name)
				link.setAttribute('ContentType', ja.get_content_type())
				art.appendChild(link)

			tulem.appendChild(art)
	     
	    #elem2 = self.dom.createElement('JamArtefact')
	    #elem2.setAttribute('Name', js.get_real_name())
	    #elem2.setAttribute('Author', str(ja.get_author()))
	    #elem2.setAttribute('ID', ja.get_id())
	    #elem.appendChild(elem2)

        vanem.appendChild(tulem)

        return tulem

    def testiPilt(self,vanem, varamu):
	if varamu.pilt is not None:
	        mat_pilt = self.dom.createElement('matimage')
	        name = self.binarydata.storeData(varamu.pilt)
	        mat_pilt.setAttribute('uri',name)
		vanem.appendChild(mat_pilt)
	return vanem

    def testiViide(self,vanem, varamu):
	if varamu.viiteURL != '':
             matem = self.dom.createElement('matemtext')
             matem.setAttribute('uri',varamu.viiteURL)
             matem.appendChild(self.dom.createTextNode(varamu.viiteTekst))
             vanem.appendChild(matem)
	return vanem

    def testiKirjeldavTekst(self,vanem,varamu):
	if varamu.kirjeldavTekst != '':
             komm = self.dom.createElement('qticomment')
             komm.appendChild(self.dom.createTextNode(varamu.kirjeldavTekst))
             vanem.appendChild(komm)
	return vanem

    def testiItem(self,vanem,varamu):
        elem = self.dom.createElement('item')
        elem.setAttribute('ident',varamu.get_id())
	elem.setAttribute('title',varamu.meta_type)
        vanem.appendChild(elem)
	return elem 

    def kirjutaTest(self, vanem):
	tulem = self.dom.createElement('questestinterop')
	komment = self.dom.createElement('qticomment')
	komment.appendChild(self.dom.createTextNode('Here is a set of questions and tests from IVA'))
	tulem.appendChild(komment)
	for hoidla in self.kursus.testid.objectValues():
	  sektion = self.dom.createElement('section')
	  sektion.setAttribute('title',hoidla.pealkiri)
	  sektion.setAttribute('ident',hoidla.get_id())
	  #print hoidla.get_id()
	  for yled in hoidla.objectValues():
		#print "->>"+yled.get_id()
		#print yled.get_id()+" - "+ yled.meta_type
		tyyp = yled.meta_type
        	if tyyp=='ValikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
			present = self.dom.createElement('presentation')
			elem.appendChild(present)
			flo = self.dom.createElement('flow')
			present.appendChild(flo)
			mat = self.dom.createElement('material')
			flo.appendChild(mat)
			mattext = self.dom.createElement('mattext')
			mattext.appendChild(self.dom.createTextNode(yled.kysimus))
			mat.appendChild(mattext)
			
			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

			resp_lid = self.dom.createElement('response_lid')
			resp_lid.setAttribute('ident',yled.get_id())
			resp_lid.setAttribute('rcardinality',"Single")
			flo.appendChild(resp_lid)

			render = self.dom.createElement('render_choice')
			resp_lid.appendChild(render)
			flow_l = self.dom.createElement('flow_label')
			render.appendChild(flow_l)
			
			resp_lab = self.dom.createElement('response_label')
			resp_lab.setAttribute('ident','T')
			flow_l.appendChild(resp_lab)
                        mat2 = self.dom.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.dom.createElement('mattext')
                        mattext2.appendChild(self.dom.createTextNode('True'))
                        mat2.appendChild(mattext2)

                        resp_lab = self.dom.createElement('response_label')
                        resp_lab.setAttribute('ident','F')
                        flow_l.appendChild(resp_lab)
                        mat2 = self.dom.createElement('material')
                        resp_lab.appendChild(mat2)
                        mattext2 = self.dom.createElement('mattext')
                        mattext2.appendChild(self.dom.createTextNode('False'))
                        mat2.appendChild(mattext2)


			resproc = self.dom.createElement('resprocessing')
			elem.appendChild(resproc)
			out = self.dom.createElement('outcomes')
			resproc.appendChild(out)
			muut = self.dom.createElement('decvar')
			muut.setAttribute('vartype','Integer')
			muut.setAttribute('maxvalue',str(yled.normPunktid))
			out.appendChild(muut)

			kond = self.dom.createElement('respcondition')
			kond.setAttribute('title','Correct')
			resproc.appendChild(kond)
			kond_var = self.dom.createElement('conditionvar')
			kond.appendChild(kond_var)
			varequal = self.dom.createElement('varequal')
			varequal.setAttribute('respident',yled.get_id())
			if yled.vastus:
				varequal.appendChild(self.dom.createTextNode('T'))
			else:
				varequal.appendChild(self.dom.createTextNode('F'))
 			kond_var.appendChild(varequal)

			setvar = self.dom.createElement('setvar')
			setvar.setAttribute('action','Add')
			setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			pass
		if tyyp=='OigeTekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.dom.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.dom.createElement('render_fib')
			render.setAttribute('fibtype','String')
			render.setAttribute('enconding','UTF_8')
                        resp_lid.appendChild(render)

                        resp_lab = self.dom.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.dom.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.dom.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.dom.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)
                        
			kond = self.dom.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.dom.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        for abc in yled.variandid:
                                varequal = self.dom.createElement('varequal')
                                varequal.setAttribute('respident',yled.get_id())
                                varequal.appendChild(self.dom.createTextNode(str(abc)))
                                kond_var.appendChild(varequal)

                        setvar = self.dom.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			
			pass
        	if tyyp=='YksikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
			self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

			self.testiViide(mat,yled)
			self.testiPilt(mat,yled)

                        resp_lid = self.dom.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
                        flo.appendChild(resp_lid)

                        render = self.dom.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
			i=0
			for abc in yled.valikud:
	                        resp_lab = self.dom.createElement('response_label')
	                        resp_lab.setAttribute('ident',str(i))
	                        render.appendChild(resp_lab)
				flow_mat = self.dom.createElement('flow_mat')
				resp_lab.appendChild(flow_mat)
	                        mat2 = self.dom.createElement('material')
	                        flow_mat.appendChild(mat2)
	                        mattext2 = self.dom.createElement('mattext')
	                        mattext2.appendChild(self.dom.createTextNode(abc))
	                        mat2.appendChild(mattext2)
				i=i+1

                        resproc = self.dom.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.dom.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.dom.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.dom.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.dom.createElement('conditionvar')
                        kond.appendChild(kond_var)
                        varequal = self.dom.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
			varequal.appendChild(self.dom.createTextNode(str(yled.oigeValik)))
			kond_var.appendChild(varequal)

                        setvar = self.dom.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
			i=0
			for abc in yled.selgitused:
				itemfeed = self.dom.createElement('itemfeedback')
				itemfeed.setAttribute('ident',str(i))
				elem.appendChild(itemfeed)
				flow_m = self.dom.createElement('flow_mat')
				itemfeed.appendChild(flow_m)
				mat = self.dom.createElement('material')
				flow_m.appendChild(mat)
				mattext = self.dom.createElement('mattext')
				mattext.appendChild(self.dom.createTextNode(abc))
				mat.appendChild(mattext)
				i=i+1
			pass
        	if tyyp=='TekstivastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.dom.createElement('response_str')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Ordered")
                        flo.appendChild(resp_lid)
			
                        render = self.dom.createElement('render_fib')
                        render.setAttribute('fibtype','String')
                        render.setAttribute('enconding','UTF_8')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.dom.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)
			pass
        	if tyyp=='MitmikvalikYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.dom.createElement('response_lid')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_lid)
			
                        render = self.dom.createElement('render_choice')
                        render.setAttribute('shuffle','Yes')
                        resp_lid.appendChild(render)
                        i=0
                        for abc in yled.valikud:
                                resp_lab = self.dom.createElement('response_label')
                                resp_lab.setAttribute('ident',str(i))
                                render.appendChild(resp_lab)
                                flow_mat = self.dom.createElement('flow_mat')
                                resp_lab.appendChild(flow_mat)
                                mat2 = self.dom.createElement('material')
                                flow_mat.appendChild(mat2)
                                mattext2 = self.dom.createElement('mattext')
                                mattext2.appendChild(self.dom.createTextNode(abc))
                                mat2.appendChild(mattext2)
                                i=i+1

                        resproc = self.dom.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.dom.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.dom.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.dom.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.dom.createElement('conditionvar')
                        kond.appendChild(kond_var)
			for abc in yled.oigedValikud:
	                        varequal = self.dom.createElement('varequal')
	                        varequal.setAttribute('respident',yled.get_id())
	                        varequal.appendChild(self.dom.createTextNode(str(abc)))
	                        kond_var.appendChild(varequal)

                        setvar = self.dom.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)
                        i=0
                        for abc in yled.selgitused:
                                itemfeed = self.dom.createElement('itemfeedback')
                                itemfeed.setAttribute('ident',str(i))
                                elem.appendChild(itemfeed)
                                flow_m = self.dom.createElement('flow_mat')
                                itemfeed.appendChild(flow_m)
                                mat = self.dom.createElement('material')
                                flow_m.appendChild(mat)
                                mattext = self.dom.createElement('mattext')
                                mattext.appendChild(self.dom.createTextNode(abc))
                                mat.appendChild(mattext)
                                i=i+1

			pass
        	if tyyp=='ArvuvahemikuliseVastusegaYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)
                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

                        resp_lid = self.dom.createElement('response_num')
                        resp_lid.setAttribute('ident',yled.get_id())
                        resp_lid.setAttribute('rcardinality',"Single")
			resp_lid.setAttribute('numtype','Decimal')
                        flo.appendChild(resp_lid)

                        render = self.dom.createElement('render_fib')
			render.setAttribute('fibtype','Decimal')
			render.setAttribute('prompt','Box')
                        resp_lid.appendChild(render)

                        resp_lab = self.dom.createElement('response_label')
                        resp_lab.setAttribute('ident','A')
                        render.appendChild(resp_lab)

                        resproc = self.dom.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.dom.createElement('outcomes')
                        resproc.appendChild(out)
			komm = self.dom.createElement('qticomment')
			komm.appendChild(self.dom.createTextNode(str(yled.arvutusTyyp)))
			out.appendChild(komm)
                        muut = self.dom.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.dom.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.dom.createElement('conditionvar')
                        kond.appendChild(kond_var)
			varless = self.dom.createElement('vargte')
			varless.setAttribute('respident',yled.get_id())
			varless.appendChild(self.dom.createTextNode(str(yled.alamPiir)))
			kond_var.appendChild(varless)
                        varequal = self.dom.createElement('varequal')
                        varequal.setAttribute('respident',yled.get_id())
                        varequal.appendChild(self.dom.createTextNode(str(yled.oigeVastus)))
                        kond_var.appendChild(varequal)
			varover = self.dom.createElement('varlte')
			varover.setAttribute('respident',yled.get_id())
			varover.appendChild(self.dom.createTextNode(str(yled.ylemPiir)))
			kond_var.appendChild(varover)

                        setvar = self.dom.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
			kond.appendChild(setvar)

			pass
        	if tyyp=='ProtsentYlesanne':
			pass
        	if tyyp=='VastavusYlesanne':
                        elem = self.testiItem(sektion,yled)
                        self.testiKirjeldavTekst(elem,yled)
                        present = self.dom.createElement('presentation')
                        elem.appendChild(present)
                        flo = self.dom.createElement('flow')
                        present.appendChild(flo)
                        mat = self.dom.createElement('material')
                        flo.appendChild(mat)

                        mattext = self.dom.createElement('mattext')
                        mattext.appendChild(self.dom.createTextNode(yled.kysimus))
                        mat.appendChild(mattext)

                        self.testiViide(mat,yled)
                        self.testiPilt(mat,yled)

			resp_grp = self.dom.createElement('response_grp')
                        resp_grp.setAttribute('ident',yled.get_id())
                        resp_grp.setAttribute('rcardinality',"Multiple")
                        flo.appendChild(resp_grp)
			render = self.dom.createElement('render_choice')
			render.setAttribute('shuffle','Yes')
			resp_grp.appendChild(render)
			i=0
			krupp = ''
			for abc in yled.vastused:
				resp_lab = self.dom.createElement('response_label')
				ident = 'p'+str(i)
				if krupp != '':
					krupp = krupp+','
				krupp = krupp + ident
				resp_lab.setAttribute('ident',ident)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
				rmat = self.dom.createElement('material')
				resp_lab.appendChild(rmat)
				rmattext = self.dom.createElement('mattext')
				rmattext.setAttribute('texttype','text/plain')
				rmattext.appendChild(self.dom.createTextNode(abc))
				rmat.appendChild(rmattext)
				i=i+1
			i=0
			for abc in yled.kysimused:
				resp_lab = self.dom.createElement('response_label')
				resp_lab.setAttribute('ident','v'+str(i))
				resp_lab.setAttribute('match_max','1')
				resp_lab.setAttribute('match_group',krupp)
				resp_lab.setAttribute('rshuffle','Yes')
				resp_lab.setAttribute('rrange','Exact')
				render.appendChild(resp_lab)
                                rmat = self.dom.createElement('material')
                                resp_lab.appendChild(rmat)
                                rmattext = self.dom.createElement('mattext')
                                rmattext.setAttribute('texttype','text/plain')
                                rmattext.appendChild(self.dom.createTextNode(abc))
                                rmat.appendChild(rmattext)
				i=i+1

                        resproc = self.dom.createElement('resprocessing')
                        elem.appendChild(resproc)
                        out = self.dom.createElement('outcomes')
                        resproc.appendChild(out)
                        muut = self.dom.createElement('decvar')
                        muut.setAttribute('vartype','Integer')
                        muut.setAttribute('maxvalue',str(yled.normPunktid))
                        out.appendChild(muut)

                        kond = self.dom.createElement('respcondition')
                        kond.setAttribute('title','Correct')
                        resproc.appendChild(kond)
                        kond_var = self.dom.createElement('conditionvar')
                        kond.appendChild(kond_var)
			jah = self.dom.createElement('and')
			kond_var.appendChild(jah)
			i=0
			for abc in yled.vastused:
				varsub = self.dom.createElement('varsubset')
				varsub.setAttribute('respident',yled.get_id())
				varsub.setAttribute('setmatch','Exact')
				varsub.appendChild(self.dom.createTextNode('v'+str(i)+','+'p'+str(i)))
				jah.appendChild(varsub)
				i=i+1
                        setvar = self.dom.createElement('setvar')
                        setvar.setAttribute('action','Add')
                        setvar.appendChild(self.dom.createTextNode(str(yled.normPunktid)))
                        kond.appendChild(setvar)
			
			pass
	  tulem.appendChild(sektion)

	vanem.appendChild(tulem)
	return tulem

    def tooManifest(self, vanem, mida='bookshelf', kes=''):
	""" Kirjuta t66riista manifest ja resursid"""
	rek = self.dom.createElement('manifest')
	rek.setAttribute('identifier',kes+self.kursusenr)
	rek.setAttribute('version','1.1')
#	rek.setAttribute('xml:base',kes+self.kursusenr+'/')
	orgz = self.dom.createElement('organizations')
	rek.appendChild(orgz)
	org = self.kirjutaToo(orgz,kes+self.kursusenr)
	if mida == 'bookshelf':
		itemid = self.kirjutaRaamatustrukt(org)
	# manifesti kylge resource
	if mida == 'bookshelf':
		resurss = self.kirjutaResurss(rek)
	if mida == 'teadmuspaja':
		tpaja = self.kirjutaTPajaRes(rek)
	if mida == 'meedia':
		mpaja = self.kirjutaMPajaRes(rek)
	if mida == 'QT':
		qt = self.kirjutaTest(rek)
	vanem.appendChild(rek)
	return rek

    def kirjutaResurss(self, vanem):
	""" Kirjutab ressursid raamaturiiulist """
	rek = self.dom.createElement('resources')
        #self.riiulidokument=Document()
        #riiul=self.riiulidokument.createElement("raamaturiiul")
        #self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata
          #et lheks samasse hoidlass
        ex.exportWebtopFolderitemid(self.kursus.gf, rek)
        #d=Dump()
        #alus.writexml(d)
	vanem.appendChild(rek)
	return rek

    def kirjutaToo(self, vanem, kes=''):
	"kirjutab organisatsiooni" 
	rek = self.dom.createElement('organization')
	rek.setAttribute('identifier','IVA')	
	rek.setAttribute('structure','hierarchical')

	tit = self.dom.createElement('title')
	tit.appendChild(self.dom.createTextNode(kes))
	rek.appendChild(tit)

	md = self.dom.createElement('metadata')
	rek.appendChild(md)
	self.rekord(md, kes, "kirjeldus")
	vanem.appendChild(rek)	
	return rek

    def rekord(self, vanem, tiitel='tiitel', desk_str='kirjeldus'):
	"lisab imsmd recordi"
	rek = self.dom.createElement('imsmd:record')
	gen = self.dom.createElement('imsmd:general')
	rek.appendChild(gen)
	tit = self.dom.createElement('imsmd:title')
	gen.appendChild(tit)
	lang = self.dom.createElement('imsmd:langstring')
	lang.setAttribute('xml:lang','en-US')
	lang.appendChild(self.dom.createTextNode(tiitel))
	tit.appendChild(lang)

	desk = self.dom.createElement('imsmd:description')
	desclang = self.dom.createElement('imsmd:langstring')
	desclang.setAttribute('xml:lang','en-US')
	desclang.appendChild(self.dom.createTextNode(desk_str))
	desk.appendChild(desclang)
	gen.appendChild(desk)

	keele = self.dom.createElement('imsmd:language')
	keele.appendChild(self.dom.createTextNode('en_US'))
	gen.appendChild(keele)
	
	vanem.appendChild(rek)
	return rek

    def lisaElement(self, manifest, elemendipealkiri):
        "Lisab manifesti elemendi"
        element=self.dom.createElement("item")        
        manifest.getElementsByTagName("organizations")[0].\
          getElementsByTagName("organization")[0].appendChild(element)
        pealkiri=self.dom.createElement("title")
        element.appendChild(pealkiri)
        pealkiri.appendChild(self.dom.createTextNode(elemendipealkiri))
        return element
        
        
    def lisaRessurss(self, manifest):
        "Lisab manifesti ressursi"
        ressurss=self.dom.createElement("resource")
        manifest.getElementsByTagName("resources")[0].appendChild(ressurss)
        return ressurss
        
#    def kirjutaOsad(self):
#       "kirjutab organisatsioonid vastavate alamprogrammide abil - nii manifesti kui kirje organisatsiooni juurde"
#       self.kirjutaRaamaturiiul()
       
       
#    def kirjutaOsa(self, nimetus):
#       "Kirjutab he organisatsiooni ja vljastab selle id"
#       nr=self.loendur.get_next_counter()
#       tekst="COURSE_"+str(nr)
#       itm=self.dom.createElement("item")
#       itm.setAttribute("identifier", tekst)
#       pealkiri=self.dom.createElement("title")
#       pealkiri.appendChild(self.dom.createTextNode(nimetus))
#       itm.appendChild(pealkiri)
#       self.orgn.appendChild(itm)
#       return tekst
       
    def kirjutaRaamatustrukt(self, vanem):
	"kirjutab raamaturiiuli struktuuri"
	riiul=self.dom.createElement("item")
	riiul.setAttribute('identifier','riiul'+self.kursusenr)
	riiul.setAttribute('structure','hierarchical')
	riiul.setAttribute('identifierref','riiul'+self.kursusenr)
	riiul.setAttribute('isvisible','true')
	ex=Exporter(self.iva)
	ex.binarydata=self.binarydata
	# .gf lisatud
	ex.exportWebtopFolderStructure(self.kursus.gf, riiul)
	vanem.appendChild(riiul)
	return riiul 
       
    def kirjutaRaamaturiiul(self):
        "Lisab vljundpuusse kursuse raamaturiiuli sisu"
        #rm=self.kirjutaManifest(self.juur, "raamaturiiul")
        rm=self.dom.createElement("raamaturiiul")
	rm.setAttribute("identifier","ivariiul")
        #self.lisaElement(rm, "riiulisisu")
        #r=self.lisaRessurss(rm)
        f=self.dom.createElement("file")
        rm.appendChild(f)
        f.setAttribute("href", "ivariiul.xml")
        self.kirjutaRaamaturiiuliSisu()
        
    def kirjutaRaamaturiiuliSisu(self):
        "Kirjutab raamaturiiuli sisu omaette faili"
        self.riiulidokument=Document()
        riiul=self.riiulidokument.createElement("raamaturiiul")
        self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata 
          #et lheks samasse hoidlasse
        ex.exportWebtopFolderContents(self.kursus.gf, riiul)
        #d=Dump()
        #alus.writexml(d)
        
    
        
    def kirjutaTestid(self):
        "Lisab vljundpuusse kursusel olevate testide lesanded"


    def pakiTulemusFaili(self, failinimi="ivaarhiiv.zip"):
        "Olemasolevate tkkide phjal luuakse zip-fail"        
        zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.dom.writexml(dump)
        zip.writestr(zipfile.ZipInfo("imsmanifest.xml"),dump.getdata())
        #dump = Dump()
        #self.riiulidokument.writexml(dump)
        #zip.writestr(zipfile.ZipInfo("riiul"+self.kursusenr+"/imsmanifest.xml"),dump.getdata())
        for name in self.binarydata.getNames():
            zip.writestr(
                zipfile.ZipInfo(name),
                str(self.binarydata.getData(name)))
        zip.close()
